#!/usr/local/bin/perl
use strict;

umask 0022;

require "some.pm";

sub header {
print <<GOBBLE_HEADER;
Content-type: text/html

<html>
</head>
<title>Registration</title>
</head>

<body bgcolor=white>

<br><br><br>
<font color=#996622><font size=+4>Registration Test</font><br>
problems?  contact dave-at-getdave.com<br>
mistakes?  contact dave-at-getdave.com<br>
</font>
<p>
GOBBLE_HEADER
}

sub ERROR { print "<h2>ERROR: @_</h2>\n"; }

sub is_registered {
  my ($who) = @_;
return 0;
}

sub handle_query {
  my ($query_H) = @_;

  my $email = $query_H->{'email'};
  my $name = $query_H->{'name'};
  my $airport = $query_H->{'airport'};
  my $time = $query_H->{'time'};
  my $ampm = $query_H->{'ampm'};
  my $day = $query_H->{'day'};
  my $flight = $query_H->{'flight'};
  my $staying = $query_H->{'staying'};
  my $homepage = $query_H->{'homepage'};

  # Make sure it looks like a valid email address
  return ERROR("No email specified") if (!$email);
  #return ERROR("Spaces are not allowed in email address") if ($email =~ / /);
  return ERROR("Invalid email (must have '\@')") if ($email !~ /@/);
  return ERROR("Specify full email address") if ($email !~ /@.+\..+/);

  return ERROR("$email already on list") if (is_registered($email));

  # Check time
  my $time = $query_H->{'time'};
  return ERROR("Missing field: Time") unless ($time);
  # Figure time out, standardize it
  if ($time =~ /\s*([ap])m?$/) {
    $time = $`;
    $ampm = $1 eq "a" ? "am" : "pm";
  }
  my ($hour,$min) = ($1,$2) if ($time =~ /^\s*(\d+):(\d+)\s*$/);
  ($hour,$min) = ($1,0) if ($time =~ /^\s*(\d+)\s*$/);
  return ERROR("Couldn't understand time: $time") unless (defined $hour && defined $min);
  return ERROR("Only 12 hours available! ($time)") unless ($time<=12);
  return ERROR("Only 60 minutes in an hour! ($min)") unless ($min<=60);
  return ERROR("Screwy field: AMPM??") unless ($ampm eq "am" || $ampm eq "pm");
  $time = sprintf("$hour:%2.2d $ampm",$min);

  # Check other fields
  return ERROR("Missing field: Name") unless ($name);
  return ERROR("Missing field: Airport?") unless ($airport);
  return ERROR("Missing field: Day?") unless ($day);
  return ERROR("Missing field: Flight") unless ($flight);
  return ERROR("Missing field: Staying In") unless ($staying);

  $homepage =~ s|^http://||;
  $homepage = $homepage ? "http://$homepage" : "0";

  # Success!
  print "<p><h3>\n";
  print "You have been succesfully added to the list:\n";
  print "</h3>\n";
}

sub footer {
  print <<GOBBLE_FOOTER;

  <p><hr><p>
  <i>Brought to you by:</i><br>
  <a href=http://GetDave.com/
     onMouseOver = document.images['GetDave'].src='http://DavePics.com/Domains/GetDave_down.gif'
      onMouseOut = document.images['GetDave'].src='http://DavePics.com/Domains/GetDave.gif'
     onMouseDown = document.images['GetDave'].src='http://DavePics.com/Domains/GetDave_down.gif'
       onMouseUp = document.images['GetDave'].src='http://DavePics.com/Domains/GetDave.gif'>
  <img name=GetDave alt="GetDave.com - Dave's Domain hub."
       src=http://DavePics.com/Domains/GetDave.gif
       width=69 height=60 border=0></a>

</body>
</html>
GOBBLE_FOOTER
}

sub show_values {
  my ($query) = @_;
  print "<p><hr><p>\n\n";
  foreach my $q ( keys %$query ) {
    print "SAW: $q -> $query->{$q}<br>\n";
  }
}

sub main {
  header();

  my @bad_fields;

  my $query = parse_query();
  my $form_number = $query->{form_number};

  # They just filled out form 2
  if ($form_number==2) {
    if (!@bad_fields && (@bad_fields = check_form_page2($query))) {
      $form_number--;		# Do again
    } else {
      show_values($query);
    }
  }

  # They just filled out form 1
  if ($form_number==1) {
    if (!@bad_fields && (@bad_fields = check_form_page1($query))) {
      $form_number--;		# Do again
    } else {
      form_page2($query,@bad_fields);
    }
  }

  if (!$form_number) {
    form_page1($query,@bad_fields);
  }

  footer();
} main();
